<template>
  <q-page
    ref="MQPage"
    :style-fn="myTweak"
    :style="{overflowY: overflowY}"
    class="bg-white" padding
  >
    <div id="mainContainer" class="column" ref="mainContainer" style="height: auto;">
      <slot name="content"/>
      <q-resize-observer @resize="onMainResize"/>
    </div>

    <!--slot header-->
    <q-page-sticky ref="toolbarIn" position="top" :expand="true" class="bg-white"
                   style="z-index: 5 !important; border-bottom: 1px solid #d5d5d5">
      <q-list v-if="isControlPanel" no-border class="col-12">
        <q-item class="q-pb-none q-mb-none row" dense>
          <q-item-label
            class=" col-xs-6 col-sm-6 q-ma-none q-pa-none q-pt-xs text-bold text-weight-bolder"
            style="font-size: 24px">
            {{pageTitle}}
          </q-item-label>
          <div class="col-sm-1 col-xs-1 col-lg-2 q-pa-none q-ma-none"></div>
          <div class="col-sm-5 col-xs-5 col-lg-4 q-pa-none q-ma-none">
            <slot name="cp_search"/>
          </div>
        </q-item>
        <q-item class="q-pb-none q-mb-none" dense>
          <q-breadcrumbs
            class="col-xs-6 col-sm-5 col-lg-5"
            active-color="primary"
            color="breadcrumb-inactive"
            separator="/"
          >
            <q-breadcrumbs-el icon="la la-home" :to="'/'">
            </q-breadcrumbs-el>
            <q-breadcrumbs-el v-for="(t,i) in breadcrumbs"
                              :key="i" :label="t.title"
                              :to="t.to"
            />
          </q-breadcrumbs>
          <div class="col-xs-6 col-sm-7 col-lg-7">
            <slot name="header"/>
          </div>
        </q-item>
      </q-list>
      <q-resize-observer @resize="onResize"/>
    </q-page-sticky>
  </q-page>
</template>

<script>

  import _ from "lodash";
  import get from "lodash/get";
  import moment from "moment";

  export default {
    name: 'PageContainer',
    props: {
      model: String,
      isControlPanel: {
        type: Boolean,
        default: true,
      },
      overflowY: {
        type: String,
        default: 'auto',
      },
    },

    data: () => {
      return {
        breadcrumbs: [],
      }
    },

    methods: {
      myTweak(offset) {
        return {minHeight: offset ? `calc(100vh - ${offset}px)` : '100vh'}
      },

      onResize(size) {
        let height = size.height
        this.$refs.mainContainer.style.marginTop = height + 'px'
      },

      onMainResize(size) {
        this.$emit('on-main-size-changed', size)
      },
    },

    watch: {
      '$route': {
        handler() {
          this.breadcrumbs = []
          this.$route.matched.forEach(x => {
            if (x.meta && x.meta.breadcrumbs) {
              this.breadcrumbs.push({
                title: x.meta.breadcrumbs,
                to: x.path,
              })
            }
          })
        },
        immediate: true,
      },
    },

    computed: {
      pageTitle() {
        let lastBreadcrumb = this.breadcrumbs ? _.last(this.breadcrumbs) : null
        return lastBreadcrumb ? lastBreadcrumb.title : 'Titre'
      }
    },

    mounted() {
      let height = (this.$refs.toolbarIn.$el.clientHeight - 1)
      let heightPage = this.$refs.MQPage.$el.clientHeight
      this.$refs.mainContainer.style.marginTop = height + 'px'
      this.$refs.mainContainer.style.minHeight = (heightPage - height) + 'px'
      this.$nextTick(function () {
      })
    },
  }
</script>

<style scoped>
</style>
